Package: EDASeq
Version: 2.40.0
Title: Exploratory Data Analysis and Normalization for RNA-Seq
Description: Numerical and graphical summaries of RNA-Seq read data.
        Within-lane normalization procedures to adjust for GC-content
        effect (or other gene-level effects) on read counts: loess
        robust local regression, global-scaling, and full-quantile
        normalization (Risso et al., 2011). Between-lane normalization
        procedures to adjust for distributional differences between
        lanes (e.g., sequencing depth): global-scaling and
        full-quantile normalization (Bullard et al., 2010).
Authors@R: c(person("Davide", "Risso", email = "risso.davide@gmail.com",
	          role = c("aut", "cre", "cph")),
	     person("Sandrine", "Dudoit", role = "aut"),
	     person("Ludwig", "Geistlinger", role = "ctb"))
Author: Davide Risso [aut, cre, cph], Sandrine Dudoit [aut], Ludwig Geistlinger [ctb]
Maintainer: Davide Risso <risso.davide@gmail.com>
Date: 08-30-2011
Depends: Biobase (>= 2.15.1), ShortRead (>= 1.11.42)
Imports: methods, graphics, BiocGenerics, IRanges (>= 1.13.9),
        aroma.light, Rsamtools (>= 1.5.75), biomaRt, Biostrings,
        AnnotationDbi, GenomicFeatures, GenomicRanges, BiocManager
Suggests: BiocStyle, knitr, yeastRNASeq, leeBamViews, edgeR,
        KernSmooth, testthat, DESeq2, rmarkdown
VignetteBuilder: knitr
License: Artistic-2.0
LazyLoad: yes
biocViews: ImmunoOncology, Sequencing, RNASeq, Preprocessing,
        QualityControl, DifferentialExpression
URL: https://github.com/drisso/EDASeq
BugReports: https://github.com/drisso/EDASeq/issues
RoxygenNote: 7.1.0
git_url: https://git.bioconductor.org/packages/EDASeq
git_branch: RELEASE_3_20
git_last_commit: fdb405f
git_last_commit_date: 2024-10-29
Repository: Bioconductor 3.20
Date/Publication: 2024-10-29
NeedsCompilation: no
Packaged: 2024-10-30 00:31:56 UTC; biocbuild

.gcLoess <- function(counts,gc) {
  ff <- function(y,x) {
    xx <- x[(y>0)&(y<=quantile(y,probs=0.99))]
    yy <- log(y[(y>0)&(y<=quantile(y,probs=0.99))])

    l <- loess(yy~xx)
    y.fit <- predict(l,newdata=x)
    names(y.fit) <- names(y)
    y.fit[is.na(y.fit)] <- 0

    retval <- y/exp(y.fit-median(yy))
    return(retval)
  }
  apply(counts,2,ff,x=gc)
}

.gcQuant <- function(counts,gc,num.bins=10,which=c("full","median","upper")) {
  which <- match.arg(which)
  bins <- cut(gc,breaks=quantile(gc,probs=seq(0,1,length.out=num.bins+1)))
  bins[is.na(bins)] <- levels(bins)[1]
  names(bins) <- names(gc)
  f <- function(y) {
    if(is.null(names(y))) {
      names(y) <- 1:length(y)
    }
    # take care of duplicate rownames
    if(any(duplicated(names(y)))){
      dups <- TRUE
      originalNames <- names(y)
      names(y) <- 1:length(y)
    } else {
      dups <- FALSE
    }
    tmp <- tapply(y,bins,function(x) x)
    switch(which,
           full = {y.norm <- normalizeQuantileRank(tmp)},
           median = {y.norm <- lapply(tmp,function(x) exp(log(x) - median(log(x)) + median(log(unlist(tmp)))))},
           upper = {y.norm <- lapply(tmp,function(x) exp(log(x) - quantile(log(x),probs=.75) + quantile(log(unlist(tmp)),prob=.75)))}
           )
    names <- unlist(sapply(y.norm,names))
    y.norm <- unlist(y.norm)
    names(y.norm) <- names
    y.norm <- y.norm[names(y)]
    if(dups) names(y.norm) <- originalNames[as.numeric(names(y.norm))]
    return(y.norm)
    }
  apply(counts,2,f)
}

setMethod(
          f = "plotQuality",
          signature = "FastqFileList", 
          definition = function(x, ..., col=rainbow(length(x)))
          {
            quals <- lapply(x, function(x) {
              fq <- quality(readFastq(x))
              wd <- unique(width(fq))
              if (1L != length(wd)) {
              minwd <- min(wd)
              message(paste("reducing width to trailing ", minwd,
                      "\n  path: ", path(x)))
              fq <- narrow(fq, start=1, end=minwd)
              }
              colMeans(as(fq, "matrix"))
            })
            wd <- max(sapply(quals, length))
            min <- min(sapply(quals, min))
            max <- max(sapply(quals, max))
            plot(quals[[1]], xlim=c(1, wd), ylim=c(min, max), type="b",
                 ..., xlab="Cycle", ylab="Quality", col=col[1])
            for (i in 1 + seq_along(quals[-1]))
              lines(quals[[i]], type="l", col=col[i])
            invisible()
          })


setMethod(
          f = "barplot",
          signature = signature(height="FastqFileList"),
          definition = function(height,...) {
            x <- lapply(height,function(x) length(readFastq(x)))
            barplot(unlist(x),...)
          }
          )

setMethod(
          f="plotNtFrequency",
          signature= signature(x="ShortRead"),
          definition = function(x,...) {
            nt <- t(alphabetByCycle(sread(x)))
            nt <- nt[,c("A","C","G","T","N")]
            nt <- t(scale(t(nt), center=FALSE, scale=rowSums(nt)))
            matplot(nt, xlab = "Cycle", ylab = "Nt frequency", type = "l", lty=1, col=1:5, ...)
            abline(h=1/4, col="gray")
            legend("topright",colnames(nt), fill=1:5,bg="white")
          }
          )

setMethod(
          f = "boxplot",
          signature = signature(x="FastqQuality"),
          definition = function(x,...) {
            bp <- as.data.frame(as(x,"matrix"))
            colnames(bp) <- as.character(1:NCOL(bp))
            boxplot(bp,...)
          }
          )

## initialize
setMethod(
          f = "initialize",
          signature = "SeqExpressionSet",
          definition = function(.Object, ..., assayData=assayDataNew(
                                   counts = matrix(0L, 0, 0),
                                   normalizedCounts =  matrix(0L, 0, 0),
                                   offset = matrix(0L, 0, 0)))
          {
            callNextMethod(.Object, ..., assayData=assayData)
          })

setValidity(
            Class= "SeqExpressionSet",
            method = function(object) {
              is.wholenumber <- function(x, tol = .Machine$double.eps^0.5) {
                abs(x - round(x)) < tol
              }
              msg <- validMsg(NULL, assayDataValidMembers(assayData(object), c("counts", "normalizedCounts", "offset")))
              if(!is.null(assayDataElement(object, "counts"))) {
                if(!is.matrix(assayDataElement(object, "counts"))) {
                  msg <- validMsg(msg, "'counts' must be an integer or numeric matrix")
                }
                if(!all(is.wholenumber(assayDataElement(object, "counts")), na.rm=TRUE)) {
                  warning("'counts' contains non-integer numbers")
                }
              }
              if (is.null(msg))
                TRUE
              else msg
            }
            )

setMethod("updateObject",
          signature = signature(object = "SeqExpressionSet"),
          definition = function(object, ..., verbose = FALSE) {
            if (verbose) {
              message("updateObject(object = 'SeqExpressionSet')")
            }
            object <- callNextMethod()
            if (isCurrent(object)["SeqExpressionSet"]) {
              return(object)
            } else {
              classVersion(object)["SeqExpressionSet"] <- classVersion("SeqExpressionSet")["SeqExpressionSet"]
              object
            }
          })

## constructor
newSeqExpressionSet <- function(counts,
                                normalizedCounts = matrix(data=NA, nrow=nrow(counts), ncol=ncol(counts),
                                  dimnames=dimnames(counts)),
                                offset = matrix(data=0, nrow=nrow(counts), ncol=ncol(counts),
                                  dimnames=dimnames(counts)),
                                phenoData = annotatedDataFrameFrom(counts, FALSE),
                                featureData = annotatedDataFrameFrom(counts, TRUE),
                                ...) {
  if(is.data.frame(phenoData)) {
    phenoData <- AnnotatedDataFrame(phenoData)
  }
  if(is.data.frame(featureData)) {
    featureData <- AnnotatedDataFrame(featureData)
  }

  new("SeqExpressionSet",
      assayData = assayDataNew(counts=counts, normalizedCounts=normalizedCounts, offset=offset),
      phenoData = phenoData,
      featureData = featureData, ...)
}


## exprs DEPRECATED
setMethod(
          f = "exprs",
          signature = "SeqExpressionSet",
          definition = function(object) {
            .Deprecated("counts")

            if(all(is.na(normCounts(object)))) {
              counts <- counts(object)
            } else {
              counts <- normCounts(object)
            }
            return(counts)
          }
        )

setReplaceMethod(
                 f = "exprs",
                 signature = "SeqExpressionSet",
                 definition = function(object, value) {
                   .Deprecated("counts<-")
                   assayDataElement(object, "counts") <- as.matrix(value)
                   validObject(object)
                   object
                 }
                 )

## counts
setMethod(
          f = "counts",
          signature = "SeqExpressionSet",
          definition = function(object) {
            assayDataElement(object, "counts")
          }
        )

setReplaceMethod(
                 f = "counts",
                 signature = "SeqExpressionSet",
                 definition = function(object,value) {
                   assayDataElement(object, "counts") <- as.matrix(value)
                   validObject(object)
                   object
                 }
                 )

## normCounts
setMethod(
          f = "normCounts",
          signature = "SeqExpressionSet",
          definition = function(object) {
            assayDataElement(object, "normalizedCounts")
          }
        )

setReplaceMethod(
                 f = "normCounts",
                 signature = "SeqExpressionSet",
                 definition = function(object,value) {
                   assayDataElement(object, "normalizedCounts") <- as.matrix(value)
                   validObject(object)
                   object
                 }
                 )

## offst
setMethod(
          f = "offst",
          signature = "SeqExpressionSet",
          definition = function(object) {
            assayDataElement(object, "offset")
          }
        )


setReplaceMethod(
                 f = "offst",
                 signature = "SeqExpressionSet",
                 definition = function(object, value) {
                   assayDataElement(object, "offset") <- as.matrix(value)
                   validObject(object)
                   object
                 }
                 )


## some graphics
setMethod(
          f = "boxplot",
          signature = "SeqExpressionSet",
          definition = function(x, ...) {
            if(all(is.na(normCounts(x)))) {
              boxplot(as.data.frame(log(counts(x) + 0.1)),...)
            } else {
              boxplot(as.data.frame(log(normCounts(x) + 0.1)),...)
            }
          }
          )


setMethod(
          f = "meanVarPlot",
          signature = "SeqExpressionSet",
          definition = function(x,log=FALSE,...) {
            if(ncol(counts(x))<=1) {
              stop("At least two samples are needed to compute variance.")
            }
            if(all(is.na(normCounts(x)))) {
              counts <- counts(x)
            } else {
              counts <- normCounts(x)
            }
            m <- apply(counts, 1, mean)
            v <- apply(counts, 1, var)
            if(log) {
              mm <- pmax(0, log(m))
              vv <- pmax(0, log(v))
            } else {
              mm <- m[m<=quantile(m,probs=.9)]
              vv <- v[m<=quantile(m,probs=.9)]
            }
            smoothScatter(mm,vv,xlab="mean",ylab="variance",...)
            lines(abline(0,1))
            lines(lowess(mm,vv),col=2)
          }
          )


setMethod(
          f = "biasPlot",
          signature = signature(x="matrix", y="numeric"),
          definition = function(x, y, cutoff=1000, log=FALSE, col=NULL, ...) {
            if(log) {
              x <- log(x + 0.1)
            }
            if(is.null(col)) {
              col <- 1:ncol(x)
            } else if(length(col) < ncol(x)) {
              col = rep(col,length.out=ncol(x))
            }
            plot(lowess(y[x[,1]<=cutoff],x[x[,1]<=cutoff,1]),type='l',col=col[1],...)
            if(ncol(x)>1) {
              for(i in 2:ncol(x)) {
                lines(lowess(y[x[,i]<=cutoff],x[x[,i]<=cutoff,i]),col=col[i],type='l',...)
              }
            }
          }
          )

setMethod(
          f = "biasPlot",
          signature = signature(x="SeqExpressionSet", y="character"),
          definition = function(x, y, cutoff=1000, log=FALSE, color_code=NULL, legend=TRUE, col=NULL, ..., xlab = y, ylab = "gene counts") {
            flag <- FALSE
            if(is.null(col)) {
              if(is.null(color_code)) {
                color_code <- 1
              }
              col <- as.numeric(as.factor(pData(x)[,color_code]))
              flag <- TRUE
            } else if(!is.null(color_code)) {
              warning("If both col and color_code are specified, col overrides color_code")
            }
            if(all(is.na(normCounts(x)))) {
              counts <- counts(x)
            } else {
              counts <- normCounts(x)
            }
            biasPlot(counts, fData(x)[,y], log=log, col=col, ..., xlab=xlab, ylab=ylab)
            if(ncol(counts)>1 & legend & flag) {
            legend("topleft",unique(as.character(pData(x)[,color_code])),fill=unique(pData(x)[,color_code]))
          }
          }
          )

setMethod(
          f = "biasBoxplot",
          signature = signature(x="numeric",y="numeric",num.bins="ANY"),
          definition = function(x, y, num.bins,...) {
            if(missing(num.bins)) {
              num.bins <- 10
            }
            bins <- cut(y,breaks=quantile(y,probs=seq(0,1,length.out=num.bins+1)))
            bins[is.na(bins)] <- levels(bins)[1]
            names(bins) <- names(y)
            boxplot(x~bins,...)
            abline(h=0,col=2)
          }
          )

setMethod(
          f = "MDPlot",
          signature = signature(x="matrix",y="numeric"),
          definition = function(x, y, controls=NULL, ...) {
            if(ncol(x)<=1) {
              stop("At least a two-column matrix needed for the mean-difference plot.")
            } else {
              mean <- rowMeans(log(x + 0.1))
              difference <- log(x[,y[2]] + 0.1)-log(x[,y[1]] + 0.1)
              smoothScatter(mean,difference,...)
              lines(lowess(mean,difference),col=1)
              abline(h=0,lty=2)
              if(!is.null(controls)) {
                points(mean[controls], difference[controls], pch=20, col=2)
                lines(lowess(mean[controls], difference[controls]), col=2)
              }
            }
          }
          )

setMethod(
          f = "MDPlot",
          signature = signature(x="SeqExpressionSet",y="numeric"),
          definition = function(x, y, controls=NULL, ...) {
            if(ncol(counts(x))<=1) {
              stop("At least two samples needed for the mean-difference plot.")
            } else {
              if(all(is.na(normCounts(x)))) {
                m <- counts(x)[,y]
              } else {
                m <- normCounts(x)[,y]
              }
              mean <- rowMeans(log(m + 0.1))
              difference <- log(m[,2] + 0.1) - log(m[,1] + 0.1)
              smoothScatter(mean,difference,...)
              lines(lowess(mean,difference),col=1)
              abline(h=0,lty=2)
              if(!is.null(controls)) {
                points(mean[controls], difference[controls], pch=20, col=2)
                lines(lowess(mean[controls], difference[controls]), col=2)
              }
            }
          }
          )


setMethod(
          f = "withinLaneNormalization",
          signature = signature(x="matrix",y="numeric"),
          definition = function(x, y, which=c("loess", "median", "upper", "full"), offset=FALSE, num.bins=10, round=TRUE) {
            which <- match.arg(which)
            if(which=="loess") {
              retval <- .gcLoess(x,y)
            } else {
              retval <- .gcQuant(x,y,num.bins,which)
            }
            if(!offset) {
              if(round) {
                retval <- round(retval)
              }
              return(retval)
            } else {
              ret <- log(retval + 0.1)-log(x + 0.1)
              return(ret)
            }
          }
          )

setMethod(
          f = "withinLaneNormalization",
          signature = signature(x="SeqExpressionSet", y="character"),
          definition = function(x, y, which=c("loess", "median", "upper", "full"),
                                offset=FALSE, num.bins=10, round=TRUE) {
            if(offset) {
              o <- withinLaneNormalization(counts(x),
                                           fData(x)[,y],
                                           which, offset, num.bins, round)
            } else {
              o <- offst(x)
            }

            newSeqExpressionSet(counts=counts(x),
                                normalizedCounts=withinLaneNormalization(counts(x),
                                  fData(x)[,y], which, offset=FALSE, num.bins, round),
                                offset=o,
                                  phenoData=phenoData(x), featureData=featureData(x))
          }
          )

#between-lane

setMethod(
          f = "betweenLaneNormalization",
          signature = signature(x="matrix"),
          definition = function(x, which=c("median", "upper", "full"), offset=FALSE, round=TRUE) {
            which <- match.arg(which)
            if(which=="full") {
              retval <- normalizeQuantileRank(as.matrix(x), robust=TRUE)
            } else {
              if(which=="upper") {
                sum <- apply(x, 2, quantile, 0.75)
              } else {
                sum <- apply(x, 2, median)
              }
              sum <- sum/mean(sum)
              retval <- scale(x, center=FALSE, scale=sum)
            }
            if(!offset) {
              if(round) {
                retval <- round(retval)
              }
              return(retval)
            } else {
              ret <- log(retval + 0.1) - log(x + 0.1)
              return(ret)
            }
          }
          )

setMethod(
          f = "betweenLaneNormalization",
          signature = signature(x="SeqExpressionSet"),
          definition = function(x, which=c("median","upper","full"), offset=FALSE, round=TRUE) {
            if(all(is.na(normCounts(x)))) {
              counts <- counts(x)
            } else {
              counts <- normCounts(x)
            }
            if(offset) {
              o = offst(x) + betweenLaneNormalization(counts, which, offset=TRUE, round)
            }
            else {
              o = offst(x)
            }
            newSeqExpressionSet(counts=counts(x),
                                  normalizedCounts=betweenLaneNormalization(counts,
                                    which, offset=FALSE, round),
                                  offset=o,
                                  phenoData=phenoData(x), featureData=featureData(x))
          }
          )

setMethod(
          f = "plotRLE",
          signature = signature(x="matrix"),
          definition = function(x,...) {
              y <- log(x+1)
              median <- apply(y, 1, median)
              rle <- apply(y, 2, function(x) x - median)

              boxplot(rle, ...)
              abline(h=0, lty=2)
              invisible(rle)
          }
          )

setMethod(
          f = "plotRLE",
          signature = signature(x="SeqExpressionSet"),
          definition = function(x, ...) {
            if(ncol(counts(x))<=1) {
              stop("At least two samples needed for the mean-difference plot.")
            } else {
              if(all(is.na(normCounts(x)))) {
                counts <- counts(x)
              } else {
                counts <- normCounts(x)
              }
              plotRLE(counts, ...)
            }
          }
          )

setMethod(
    f = "plotPCA",
    signature = signature(object="matrix"),
    definition = function(object, k=2, labels=TRUE, isLog=FALSE, ...) {
        if(!isLog) {
            Y <- apply(log(object+1), 1, function(y) scale(y, center=TRUE, scale=FALSE))
        } else {
            Y <- apply(object, 1, function(y) scale(y, center=TRUE, scale=FALSE))
        }
        s <- svd(Y)
        percent <- s$d^2/sum(s$d^2)*100
        labs <- sapply(seq_along(percent), function(i) {
            paste("PC ", i, " (", round(percent[i], 2), "%)", sep="")
        })

        if(k>ncol(object)) {
            stop("The number of PCs must be less than the number of samples.")
        }

        if(k<2) {
            stop("The number of PCs must be at least 2.")
        } else if (k==2) {
            if(labels) {
                plot(s$u[,1], s$u[,2], type='n', ...,
                     xlab=labs[1], ylab=labs[2])
                text(s$u[,1], s$u[,2], labels=colnames(object), ...)
            } else {
                plot(s$u[,1], s$u[,2], ...,
                     xlab=labs[1], ylab=labs[2])
            }
        } else {
            colnames(s$u) <- labs
            pairs(s$u[,1:k], ...)
        }
    }
)

setMethod(
          f = "plotPCA",
          signature = signature(object="SeqExpressionSet"),
          definition = function(object, k=2, labels=TRUE, ...) {
            if(ncol(counts(object))<=1) {
              stop("At least two samples needed for the PCA plot.")
            } else {
              if(all(is.na(normCounts(object)))) {
                counts <- counts(object)
              } else {
                counts <- normCounts(object)
              }
              plotPCA(counts, k=k, labels=labels, isLog=FALSE, ...)
            }
          }
          )

context("Test plot functions.")

set.seed(42)

mat <- matrix(data=rpois(1000, lambda=10), ncol=10)
rownames(mat) <- paste("gene", 1:nrow(mat), sep="")
colnames(mat) <- paste("sample", 1:ncol(mat), sep="")

es <- newSeqExpressionSet(mat)

test_that("setters and getters works", {

  counts(es) <- mat
  expect_equal(counts(es), mat)

  normCounts(es) <- mat
  expect_equal(normCounts(es), mat)
})

test_that("between-lane normalization works", {

  es <- newSeqExpressionSet(mat)
  es2 <- newSeqExpressionSet(mat)

  # full
  norm_mat <- betweenLaneNormalization(mat, which="full")
  normCounts(es2) <- norm_mat
  es3 <- betweenLaneNormalization(es, which="full")

  expect_equal(es2, es3)

  # median
  norm_mat <- betweenLaneNormalization(mat, which="median")
  normCounts(es2) <- norm_mat
  es3 <- betweenLaneNormalization(es, which="median")

  expect_equivalent(es2, es3)

  # upper
  norm_mat <- betweenLaneNormalization(mat, which="upper")
  normCounts(es2) <- norm_mat
  es3 <- betweenLaneNormalization(es, which="upper")

  expect_equivalent(es2, es3)

})

test_that("within-lane normalization works", {

  gc <- rnorm(100)
  es <- newSeqExpressionSet(mat, featureData = data.frame(gc=gc, row.names=rownames(mat)))
  es2 <- es

  # full
  norm_mat <- withinLaneNormalization(mat, gc, which="full")
  normCounts(es2) <- norm_mat
  es3 <- withinLaneNormalization(es, "gc", which="full")

  expect_equal(es2, es3)

  # median
  norm_mat <- withinLaneNormalization(mat, gc, which="median")
  normCounts(es2) <- norm_mat
  es3 <- withinLaneNormalization(es, "gc", which="median")

  expect_equivalent(es2, es3)

  # upper
  norm_mat <- withinLaneNormalization(mat, gc, which="upper")
  normCounts(es2) <- norm_mat
  es3 <- withinLaneNormalization(es, "gc", which="upper")

  expect_equivalent(es2, es3)

  # loess
  norm_mat <- withinLaneNormalization(mat, gc, which="loess")
  normCounts(es2) <- norm_mat
  es3 <- withinLaneNormalization(es, "gc", which="loess")

  expect_equivalent(es2, es3)
})

context("Test plot functions.")

set.seed(42)

mat <- matrix(data=rpois(1000, lambda=10), ncol=10)
rownames(mat) <- paste("gene", 1:nrow(mat), sep="")
colnames(mat) <- paste("sample", 1:ncol(mat), sep="")

es <- newSeqExpressionSet(mat)

test_that("plotPCA works", {
  ks <- 2:5

  ## matrix
  expect_silent(lapply(ks, function(k) plotPCA(mat, k=k)))
  expect_silent(lapply(ks, function(k) plotPCA(mat, k=k, labels=FALSE)))
  expect_silent(lapply(ks, function(k) plotPCA(mat, k=k)))
  expect_silent(lapply(ks, function(k) plotPCA(mat, k=k, labels=FALSE, pch=20, col=1:2)))

  ## expressionset
  expect_silent(lapply(ks, function(k) plotPCA(es, k=k)))
  expect_silent(lapply(ks, function(k) plotPCA(es, k=k, labels=FALSE)))
  expect_silent(lapply(ks, function(k) plotPCA(es, k=k, labels=FALSE, pch=20, col=1:2)))

})

test_that("plotRLE works", {

  ## matrix
  rle <- plotRLE(mat)
  expect_equal(dim(mat), dim(rle))

  ## expressionset
  rle <- plotRLE(es)
  expect_equal(dim(mat), dim(rle))

})

setClass(
         Class = "SeqExpressionSet",
         contains = "eSet",
         prototype = prototype(new("VersionedBiobase",
           versions = c(classVersion("eSet"), SeqExpressionSet = "1.0.0")))
         )

############################################################
#
# author: Ludwig Geistlinger
# date: 2015-03-10 13:32:37
#
# descr: get.gene.length.and.gc.content
# update: 2015-06-14 exonic sequences
############################################################

#
# @input:
#   - id: one or more gene IDs (ensembl or entrez)
#   - org: organism three letter code, e.g. 'hsa' for 'Homo sapiens'
#   - mode: 1. biomart (supports all ensembl organisms, but might be a time-consuming)
#           2. org.db (based on BioC annotation, which is much faster but only
#                    for organisms with a respective TxDb, BSgenome, and OrgDb package)
getGeneLengthAndGCContent <- function(id, org, mode=c("biomart", "org.db"))
{
    id.type <- .autoDetectGeneIdType(id[1])
    if(is.na(id.type))
        stop("Only ENTREZ or ENSEMBL gene IDs are supported.")

    mode <- match.arg(mode)
    inp.id <- id

    # (a) based on BioC annotation utilities:
    #       (0) OrgDb: map between identifiers (if necessary)
    #       (1) TxDB: get genomic coordinates of genes
    #       (2) BSgenome: get sequences of genomic coordinates
    #
    if(mode=="org.db")
    {
        # check for TxDb package
        txdb.pkg <- .org2pkg(org, type="TxDb")
        .isAvailable(txdb.pkg, type="TxDb")

        # check for BSgenome package
        bsgen.pkg <- .org2pkg(org, type="BSgenome")
        .isAvailable(bsgen.pkg, type="BSgenome")

        txdb.spl <- unlist(strsplit(txdb.pkg, "\\."))
        txdb.id.type <- txdb.spl[length(txdb.spl)]
        if(txdb.id.type == "ensGene") {
          txdb.id.type <- "ensembl"
        } else if(txdb.id.type == "knownGene") {
          txdb.id.type <- "entrez"
        } else if(txdb.id.type == "sgdGene") {
          txdb.id.type <- "sgd"
        } else {
          stop(paste("TxDb does not use ENSEMBL or ENTREZ gene IDs"))
        }

        # (0) map ensembl <-> entrez,
        # if given id.type is entrez, but Txdb uses ensembl (or vice versa)
        if(id.type != txdb.id.type)
        {
            orgdb.pkg <- .org2pkg(org)
            .isAvailable(orgdb.pkg)
            orgdb.pkg <- get(orgdb.pkg)
            id.map <- mapIds(orgdb.pkg, keys=id,
                column=ifelse(id.type == "entrez", "ENSEMBL", "ENTREZID"),
                keytype=ifelse(id.type == "entrez", "ENTREZID", "ENSEMBL"))
            id <- id.map[!is.na(id.map)]
        }

        # (1) get genomic coordinates
        txdb.pkg <- get(txdb.pkg)
        coords <- exonsBy(txdb.pkg, by="gene")
        id <- id[id %in% names(coords)]
        coords <- reduce(coords[id])
        len <- sum(width(coords))

        # (2) get sequences
        bsgen.pkg <- get(bsgen.pkg)
        seqs <- getSeq(bsgen.pkg, coords)
        af <- alphabetFrequency(unlist(seqs, use.names=FALSE), baseOnly=TRUE, as.prob=TRUE)
        gc.cont <- mean(relist(rowSums(af[,c("C", "G")]), seqs))
    }
    # (b) based on BioMart
    #
    #
    else
    {
        id.type <- paste0(id.type, ifelse(id.type=="entrez", "gene", "_gene_id"))

        # setting mart
        message("Connecting to BioMart ...")
        ensembl <- useMart("ENSEMBL_MART_ENSEMBL", host="www.ensembl.org")
        ds <- listDatasets(ensembl)[,"dataset"]
        ds <- grep(paste0("^", org), ds, value=TRUE)
        if(length(ds) == 0)
            stop(paste("Mart not found for:", org))
        else if(length(ds) > 1)
        {
            message("Found several marts")
            sapply(ds, function(d)
                message(paste(which(ds==d), d, sep=": ")))
            n <- readline(paste0("Choose mart (1-", length(ds),") : "))
            ds <- ds[as.integer(n)]
        }

        ensembl <- useDataset(ds, mart=ensembl)

        message( paste0( "Downloading sequence",
            ifelse(length(id) > 1, "s", ""), " ..."))
        if(length(id) > 100) message("This may take a few minutes ...")

        # download sequence
        # (1) get exon coordinates
        attrs <- c(id.type, "ensembl_exon_id",
            "chromosome_name", "exon_chrom_start", "exon_chrom_end")
        coords <- getBM(filters=id.type, attributes=attrs, values=id, mart=ensembl)
        id <- unique(coords[,id.type])
        coords <- GRangesList(sapply(id,
            function(i)
            {
                i.coords <- coords[coords[,1]== i, 3:5]
                g <- GRanges(i.coords[,1], IRanges(i.coords[,2],i.coords[,3]))
                return(g)
            }), compress=FALSE)
        coords <- reduce(coords)
        len <- sum(width(coords))

        # (2) get genes and sequences
        sel <- c(id.type, "start_position", "end_position")
        gene.pos <- getBM(attributes = sel, filters=id.type, values=id,
                          mart=ensembl)
        gene.seqs <- getSequence(id=id,
            type=id.type, seqType="gene_exon_intron", mart=ensembl)

        # (3) get exonic sequences and correspondig GC content
        gc.cont <- sapply(id,
            function(i)
            {
                # exon coordinates, gene position & sequence for current id i
                ecoords <- coords[[i]]
                gpos <- gene.pos[gene.pos[,id.type] == i,
                        c("start_position", "end_position")]
                gseq <- DNAString(
                    gene.seqs[gene.seqs[,id.type] == i, "gene_exon_intron"])

                # exon coordinates relative to gene position
                start <- start(ranges(ecoords)) - gpos[1,1] + 1
                end <- end(ranges(ecoords)) - gpos[1,1] + 1
                eseq <- gseq[IRanges(start, end)]
                gc.cont <- sum(alphabetFrequency(eseq, as.prob=TRUE)[c("C","G")])
                return(gc.cont)
            }
        )
    }

    res <- cbind(len, gc.cont)
    colnames(res) <- c("length", "gc")
    rownames(res) <- id

    # (4) order according to input ids
    if(mode == "org.db")
        if(id.type != txdb.id.type)
            rownames(res) <- names(id)

    not.found <- !(inp.id %in% rownames(res))
    na.col <- rep(NA, sum(not.found))
    rn <- c(rownames(res), inp.id[not.found])
    res <- rbind(res, cbind(na.col, na.col))
    rownames(res) <- rn
    res <- res[inp.id,]
    return(res)
}


.isAvailable <- function(pkg, type="annotation")
{
    if(!(pkg %in% .packages(all.available=TRUE)))
    {
        message(paste0("Corresponding ", type,  " package not found: ",
            pkg, "\nMake sure that you have it installed."))
        choice <- readline("Install it now? (y/n): ")
        if(choice == "y")
        {
            if (!requireNamespace("BiocManager", quietly=TRUE))
                install.packages("BiocManager")
            BiocManager::install(pkg)
        }
        else stop(paste("Package", pkg, "is not available"))
    }
    require(pkg, character.only = TRUE)
}

.autoDetectGeneIdType <- function(id)
{
    type <- NA
    if(grepl("^[Ee][Nn][Ss][A-Za-z]{0,3}[Gg][0-9]+", id)) type <- "ensembl"
    else if(grepl("^[0-9]+$", id)) type <- "entrez"
    else if(grepl("^[Yy][A-Za-z]{2}[0-9]{3}[A-Za-z]", id)) type <- "sgd"
    else if(grepl("^[Aa][Tt][0-9][A-Za-z][0-9]{5}", id)) type <- "tair"
    return(type)
}

.getOrgIdType <- function(org)
{
    it <- "eg"
    if(org == "At") it <- "tair"
    else if(org == "Pf") it <- "plasmo"
    else if(org == "Sc") it <- "sgd"
    return(it)
}

.supportedOrganisms <- function() sub(".db0$", "", .availableOrgPkgs())

.availableOrgPkgs <- function(type=c("OrgDb", "TxDb", "BSgenome"), local=TRUE)
{
    if(local) pkgs <- .packages(all.available=TRUE)
    else pkgs <- available.packages(paste0("http://bioconductor.org/",
        "packages/release/data/annotation/src/contrib"))[, "Package"]

    type <- match.arg(type)
    org.string <- "^org.[A-z][a-z]+.[a-z]+.db$"
    if(type == "TxDb")
        org.string <- "^TxDb.[A-Z][a-z]+.UCSC.[a-z]{2}[A-Za-z]*[0-9]{1,3}.[a-z]{3,5}Gene$"
    else if(type == "BSgenome")
        org.string <- "^BSgenome.[A-Z][a-z]+.UCSC.[a-z]{2}[A-Za-z]*[0-9]{1,3}$"
    org.pkgs <- grep(org.string, pkgs, value=TRUE)
    names(org.pkgs) <- NULL
    return(org.pkgs)
}

.org2pkg <- function(org, type=c("OrgDb", "TxDb", "BSgenome"))
{
    type <- match.arg(type)

    SPECIES <- rbind(
        c("anopheles", "Anopheles gambiae", "Ag", "aga", "anoGam", "7165"),
        c("arabidopsis", "Arabidopsis thaliana", "At", "ath", NA, "3702"),
        c("bovine", "Bos taurus", "Bt", "bta", "bosTau", "9913"),
        c("canine", "Canis familiaris", "Cf", "cfa", "canFam", "9615"),
        c("chicken", "Gallus gallus", "Gg", "gga", "galGal", "9031"),
        c("chimp", "Pan troglodytes", "Pt", "ptr", "PanTro", "9598"),
        c("ecoliK12", "Escherichia coli K12", "EcK12", "eco", NA, "562,83333,511145"),
        c("ecoliSakai", "Escherichia coli Sakai", "EcSakai", "ecs", NA, "83334"),
        c("fly", "Drosophila melanogaster", "Dm", "dme", "dm", "7227"),
        c("human", "Homo sapiens", "Hs", "hsa", "hg", "9606"),
        c("malaria", "Plasmodium falciparum", "Pf", "pfa", NA, "5833"),
        c("mouse", "Mus musculus", "Mm", "mmu", "mm", "10090"),
        c("pig", "Sus scrofa", "Ss", "ssc", "susScr", "9823"),
        c("rat", "Rattus norvegicus", "Rn", "rno", "rn", "10116"),
        c("rhesus", "Macaca mulatta", "Mmu", "mcc", "rheMac", "9544"),
        c("worm", "Caenorhabditis elegans", "Ce", "cel", "ce", "6239"),
        c("xenopus", "Xenopus laevis", "Xl", "xla", "NA", "8355"),
        c("yeast", "Saccharomyces cerevisiae", "Sc", "sce", "sacCer", "4932,559292"),
        c("zebrafish", "Danio rerio", "Dr", "dre", "danRer", "7955")
    )
    colnames(SPECIES) <- c("common", "tax", "bioc", "kegg", "ucsc", "ncbi")


    # org specification via
    # (a) 3-letter code, e.g. 'hsa'
    # (b) genome assembly, e.g. 'hg38'
    is.genome <- sub("[0-9]+$", "", org) %in% SPECIES[,"ucsc"]
    if(is.genome)
    {
        ucsc.id <- org
        i <- grep(sub("[0-9]+$", "", org), SPECIES[,"ucsc"])
        bioc.id <- SPECIES[i, "bioc"]
    }
    else
    {
        ind <- apply(SPECIES, 1, function(r) org %in% r)
        if(any(ind)) i <- which(ind)[1]
        else stop(paste0("unrecognized organism ID \'", org, "\'"))
        bioc.id <- SPECIES[i, "bioc"]
        ucsc.id <- SPECIES[i, "ucsc"]
    }

    # TxDB, BSgenome, or OrgDB package?
    if(type %in% c("TxDb", "BSgenome"))
    {
        pkg.string <- paste0("^", type, ".", bioc.id, "[a-z]+.UCSC.", ucsc.id)
        pkg <- grep(pkg.string, .availableOrgPkgs(type), value=TRUE)
        if(length(pkg) == 0)
            pkg <- grep(pkg.string, .availableOrgPkgs(type, local=FALSE), value=TRUE)
        if(length(pkg) == 0)
            stop(paste("No corresponding", type, "package for", org))
        else if(length(pkg) > 1)
        {
            message("Found several genome assemblies")
            sapply(pkg, function(p)
                message(paste(which(pkg==p), p, sep=": ")))
            n <- readline(paste0("Choose assembly (1-", length(pkg),") : "))
            pkg <- pkg[as.integer(n)]

            #message("Found several genome assemblies")
            #message(paste("Using latest:", pkg))
            #ver <- sapply(pkg,
            #    function(p)
            #    {
            #        spl <- unlist(strsplit(p, "\\."))
            #        ind <- length(spl)
            #        if(type == "TxDb") ind <- ind - 1
            #        ass <- spl[ind]
            #        ver <- sub("^[a-zA-Z]+", "", ass)
            #        return(as.integer(ver))
            #    })
            #pkg <- pkg[which.max(ver)]
        }
    }
    else
    {
        id.type <- .getOrgIdType(bioc.id)
        pkg <- paste("org", bioc.id, id.type, "db", sep=".")
    }
    return(pkg)
}

#plot methods
setMethod(
          f = "barplot",
          signature = signature(height="BamFileList"),
          definition = function(height,unique=FALSE,...) {
              bars <- countBam(height)$records
              names(bars) <- names(height)
              barplot(bars,...)
            }
          )

setMethod(
          f = "plotQuality",
          signature = "BamFileList", 
          definition = function(x, ..., col=rainbow(length(x)))
          {
            param <- ScanBamParam(what=c("strand","qual"))
            quals <- lapply(x, function(x) {
              bam <- scanBam(x, param=param)
              strand <- bam[[1]]$strand
              fq <- bam[[1]]$qual
              wd <- unique(width(fq))
              if (1L != length(wd)) {
                  minwd <- min(wd)
                  message(paste("reducing width to trailing ", minwd,
                                "\n  path: ", path(x)))
                  fq <- narrow(fq, start=1, end=minwd)
              }
              quality <- as(fq[strand=="+" | is.na(strand)], "matrix")
              quality <- rbind(quality,as(fq[strand=="-" & !is.na(strand)], "matrix")[,NCOL(quality):1])
              colMeans(quality)
            })
            wd <- max(sapply(quals, length))
            min <- min(sapply(quals, min))
            max <- max(sapply(quals, max))
            plot(quals[[1]], xlim=c(1, wd), ylim=c(min, max), type="l",
                 ..., xlab="Cycle", ylab="Quality", col=col[1])
            for (i in 1 + seq_along(quals[-1]))
              lines(quals[[i]], type="l", col=col[i])
            invisible()
          })

setMethod(
          f = "plot",
          signature = signature(x="BamFileList",y="FastqFileList"),
          definition = function(x,y,unique=FALSE,...) {
            if(!is.null(elementMetadata(x)) & !is.null(elementMetadata(y))) {
              if(!identical(elementMetadata(x),elementMetadata(y)))
                stop("x and y must have the same elementMetadata")
            }
            countBam(x)$records
            param <- ScanBamParam(what="seq")
            fq <- sapply(y,function(y) length(readFastq(y)))
            all <-countBam(x)$records
            if(unique) {
              unique <-  sapply(x,function(x) length(unique(unlist(scanBam(x,param=param))$seq)))
              nonunique <- all - unique
              bars <- t(cbind(unique,nonunique))
              barplot(t(t(bars)/fq),...)
            } else {
              barplot(all/fq,...)
            }
          }
          )

setMethod(
          f = "plotQuality",
          signature = "BamFile", 
          definition = function(x, ..., col=rainbow(length(x)))
          {
            param <- ScanBamParam(what=c("strand","qual"))
            bam <- scanBam(x, param=param)
            fq <- bam[[1]]$qual
            strand <- bam[[1]]$strand
            wd <- unique(width(fq))
            if (1L != length(wd)) {
              minwd <- min(wd)
              message(paste("reducing width to trailing ", minwd,
                      "\n  path: ", path(x)))
              fq <- narrow(fq, start=1, end=minwd)
          }
            quality <- as(fq[strand=="+" | is.na(strand)], "matrix")
            quality <- rbind(quality,as(fq[strand=="-" & !is.na(strand)], "matrix")[,NCOL(quality):1])
            boxplot(quality,...)
          }
          )

setMethod(
          f = "barplot",
          signature = signature(height="BamFile"),
          definition = function(height,strata=c("rname","strand"),...) {
            st <- match.arg(strata)
            param <- ScanBamParam(what=st)
            bam <- scanBam(height, param=param)
            res <- bam[[1]][[1]]
            barplot(table(res),...)
          }
          )

setMethod(
          f="plotNtFrequency",
          signature= signature(x="BamFile"),
          definition = function(x,...) {
            param <- ScanBamParam(what=c("strand","seq"))
            bam <- scanBam(x, param=param)
            res <- bam[[1]]$seq
            strand <- bam[[1]]$strand
            nt <- t(alphabetByCycle(res[strand=="+" | is.na(strand)]))
            nt <- nt + t(alphabetByCycle(res[strand=="-" & !is.na(strand)]))[NROW(nt):1,]
            nt <- nt[,c("A","C","G","T","N")]
            nt <- t(scale(t(nt), center=FALSE, scale=rowSums(nt)))
            matplot(nt, xlab = "Cycle", ylab = "Nt frequency", type = "l", lty=1, col=1:5, ...)
            abline(h=1/4, col="gray")
            legend("bottomright",colnames(nt), fill=1:5,bg="white")
          }
          )

setGeneric(
           name = "plotQuality",
           def = function(x,...) {standardGeneric("plotQuality")}
           )

setGeneric(
           name = "biasPlot",
           def = function(x,y,...) {standardGeneric("biasPlot")}
           )

setGeneric(
           name = "meanVarPlot",
           def = function(x,...) {standardGeneric("meanVarPlot")}
           )

setGeneric(
           name = "MDPlot",
           def = function(x,y,...) {standardGeneric("MDPlot")}
           )

setGeneric(
           name = "biasBoxplot",
           def = function(x,y,num.bins,...) {standardGeneric("biasBoxplot")}
           )

setGeneric(
           name = "offst",
           def = function(object) {standardGeneric("offst")}
           )

setGeneric(
           name = "offst<-",
           def = function(object,value) {standardGeneric("offst<-")}
           )

setGeneric(
           name = "betweenLaneNormalization",
           def = function(x, which=c("median","upper","full"), offset=FALSE, round=TRUE) {standardGeneric("betweenLaneNormalization")}
           )

setGeneric(
           name = "withinLaneNormalization",
           def = function(x, y, which=c("loess","median","upper","full"), offset=FALSE, num.bins=10, round=TRUE) {standardGeneric("withinLaneNormalization")}
           )

setGeneric(
           name = "plotNtFrequency",
           def = function(x,...) {standardGeneric("plotNtFrequency")}
           )

setGeneric(
           name = "plotRLE",
           def = function(x,...) {standardGeneric("plotRLE")}
           )

setGeneric(
           name = "normCounts",
           def = function(object) {standardGeneric("normCounts")}
           )

setGeneric(
           name = "normCounts<-",
           def = function(object, value) {standardGeneric("normCounts<-")}
           )

## ----setup, echo=FALSE------------------------------------
library(knitr)
opts_chunk$set(cache=FALSE, message=FALSE, echo=TRUE, results="markup")
options(width=60)

## ----data-------------------------------------------------
library(EDASeq)
library(yeastRNASeq)
library(leeBamViews)

## ----import-raw-------------------------------------------
files <- list.files(file.path(system.file(package = "yeastRNASeq"),
                              "reads"), pattern = "fastq", full.names = TRUE)
names(files) <- gsub("\\.fastq.*", "", basename(files))
met <- DataFrame(conditions=c(rep("mut",2), rep("wt",2)),
                 row.names=names(files))
fastq <- FastqFileList(files)
elementMetadata(fastq) <- met
fastq

## ----import-aligned---------------------------------------
files <- list.files(file.path(system.file(package = "leeBamViews"), "bam"),
                    pattern = "bam$", full.names = TRUE)
names(files) <- gsub("\\.bam", "", basename(files))

gt <- gsub(".*/", "", files)
gt <- gsub("_.*", "", gt)
lane <- gsub(".*(.)$", "\\1", gt)
geno <- gsub(".$", "", gt)

pd <- DataFrame(geno=geno, lane=lane,
                row.names=paste(geno,lane,sep="."))

bfs <- BamFileList(files)
elementMetadata(bfs) <- pd
bfs

## ----plot-total-------------------------------------------
colors <- c(rep(rgb(1,0,0,alpha=0.7),2),
            rep(rgb(0,0,1,alpha=0.7),2),
            rep(rgb(0,1,0,alpha=0.7),2),
            rep(rgb(0,1,1,alpha=0.7),2))
barplot(bfs,las=2,col=colors)

## ----plot-total-2-----------------------------------------
plotQuality(bfs,col=colors,lty=1)
legend("topright",unique(elementMetadata(bfs)[,1]), fill=unique(colors))

## ----plot-qual--------------------------------------------
plotQuality(bfs[[1]],cex.axis=.8)
barplot(bfs[[1]],las=2)

## ----plot-nt----------------------------------------------
plotNtFrequency(bfs[[1]])

## ----load-gene-level--------------------------------------
data(geneLevelData)
head(geneLevelData)

## ----load-lgc---------------------------------------------
data(yeastGC)
head(yeastGC)
data(yeastLength)
head(yeastLength)

## ----filter-----------------------------------------------
filter <- apply(geneLevelData,1,function(x) mean(x)>10)
table(filter)
common <- intersect(names(yeastGC),
                    rownames(geneLevelData[filter,]))
length(common)

## ----create-object----------------------------------------
feature <- data.frame(gc=yeastGC,length=yeastLength)
data <- newSeqExpressionSet(counts=as.matrix(geneLevelData[common,]),
                            featureData=feature[common,],
                            phenoData=data.frame(
                              conditions=factor(c(rep("mut",2),rep("wt",2))),
                              row.names=colnames(geneLevelData)))
data

## ----show-data--------------------------------------------
head(counts(data))
pData(data)
head(fData(data))

## ----show-offset------------------------------------------
head(offst(data))

## ----boxplot-genelevel------------------------------------
boxplot(data,col=colors[1:4])

## ----md-plot----------------------------------------------
MDPlot(data,c(1,3))

## ----plot-mean-var----------------------------------------
meanVarPlot(data[,1:2], log=TRUE, ylim=c(0,16))
meanVarPlot(data, log=TRUE, ylim=c(0,16))

## ----plot-gc----------------------------------------------
biasPlot(data, "gc", log=TRUE, ylim=c(1,5))

## ----boxplot-gc-------------------------------------------
lfc <- log(counts(data)[,3]+0.1) - log(counts(data)[,1]+0.1)
biasBoxplot(lfc, fData(data)$gc)

## ----normalization----------------------------------------
dataWithin <- withinLaneNormalization(data,"gc", which="full")
dataNorm <- betweenLaneNormalization(dataWithin, which="full")

## ----plot-gc-norm-----------------------------------------
biasPlot(dataNorm, "gc", log=TRUE, ylim=c(1,5))
boxplot(dataNorm, col=colors)

## ----norm-offset------------------------------------------
dataOffset <- withinLaneNormalization(data,"gc",
                                      which="full",offset=TRUE)
dataOffset <- betweenLaneNormalization(dataOffset,
                                       which="full",offset=TRUE)

## ----edger------------------------------------------------
library(edgeR)
design <- model.matrix(~conditions, data=pData(dataOffset))

y <- DGEList(counts=counts(dataOffset),
             group=pData(dataOffset)$conditions)
y$offset <- -offst(dataOffset)
y <- estimateDisp(y, design)

fit <- glmFit(y, design)
lrt <- glmLRT(fit, coef=2)
topTags(lrt)

## ----deseq------------------------------------------------
library(DESeq2)
dds <- DESeqDataSetFromMatrix(countData = counts(dataOffset),
                              colData = pData(dataOffset),
                              design = ~ conditions)

normFactors <- exp(-1 * offst(dataOffset))
normFactors <- normFactors / exp(rowMeans(log(normFactors)))
normalizationFactors(dds) <- normFactors

dds <- DESeq(dds)
res <- results(dds)
res

## ----unrounded--------------------------------------------
dataNorm <- betweenLaneNormalization(data, round=FALSE, offset=TRUE)

norm1 <- normCounts(dataNorm)
norm2 <- exp(log(counts(dataNorm) + 0.1 ) + offst(dataNorm)) - 0.1

head(norm1 - norm2)

## ----rounded----------------------------------------------
head(round(normCounts(dataNorm)) - round(counts(dataNorm) * exp(offst(dataNorm))))

## ----getLengthAndGC, eval=FALSE---------------------------
#  getGeneLengthAndGCContent(id=c("ENSG00000012048", "ENSG00000139618"), org="hsa")

## ----getLengthAndGC-full, eval=FALSE----------------------
#  fData(data) <- getGeneLengthAndGCContent(featureNames(data),
#                                                org="sacCer3", mode="org.db")

## ----sessionInfo------------------------------------------
sessionInfo()

context("Test same ordering of rows after normalization if no rownames.")

counts <- matrix(rnbinom(n=1e3, size=2,
                         mu=rnorm(n=1e3, mean=100, sd=10)),
                 nrow=100, ncol=10)
gc <- runif(n=100, min=0.3, max=0.8)

test_that("ordering is correct without rownames", {
  # normalize a matrix without rownames (and strip any name given by the function)
  normCounts_noNames <- unname(withinLaneNormalization(unname(counts), gc, which="full"))
  # normalize a matrix with rownames (and strip any name given by the function)
  rownames(counts) <- paste0("gene", 1:nrow(counts))
  normCounts_withNames <- unname(withinLaneNormalization(counts, gc, which="full"))

  expect_equal(normCounts_noNames, normCounts_withNames)
}
)

---
title: "EDASeq: Exploratory Data Analysis and Normalization for RNA-Seq"
author: "Davide Risso"
date: "Last modified: May 17, 2018; Compiled: `r format(Sys.time(), '%B %d, %Y')`"
bibliography: biblio.bib
output:
  BiocStyle::html_document:
    toc: true
vignette: >
  %\VignetteEncoding{UTF-8}
---

<!--
%\VignetteEngine{knitr::rmarkdown}
%\VignetteIndexEntry{EDASeq Vignette}
-->

# Introduction

In this document, we show how to conduct Exploratory Data Analysis
(EDA) and normalization for a typical RNA-Seq experiment using the
package `EDASeq`.

One can think of EDA for RNA-Seq as a two-step process: "read-level"
EDA helps in discovering lanes with low sequencing depths, quality
issues, and unusual nucleotide frequencies, while ``gene-level'' EDA
can capture mislabeled lanes, issues with distributional assumptions
(e.g., over-dispersion), and GC-content bias.

The package also implements both "within-lane" and "between-lane"
normalization procedures, to account, respectively, for within-lane
gene-specific (and possibly lane-specific) effects on read counts
(e.g., related to gene length or GC-content) and for between-lane
distributional differences in read counts (e.g., sequencing depths).

To illustrate the functionality of the `EDASeq` package, we
make use of the _Saccharomyces cerevisiae_ RNA-Seq data from
[@lee2008novel]. Briefly, a wild-type strain and three mutant
strains were sequenced using the Solexa 1G Genome Analyzer.  For each
strain, there are four technical replicate lanes from the same library
preparation. The reads were aligned using `Bowtie`
[@langmead2009ultrafast], with unique mapping and allowing up to
two mismatches.

The `leeBamViews` package provides a subset of the aligned
reads in BAM format. In particular, only the reads mapped between
bases 800,000 and 900,000 of chromosome XIII are considered. We use
these reads to illustrate read-level EDA.

The `yeastRNASeq` package contains gene-level read counts for
four lanes: two replicates of the wild-type strain ("wt") and
two replicates of one of the mutant strains ("mut").  We use
these data to illustrate gene-level EDA.

```{r setup, echo=FALSE}
library(knitr)
opts_chunk$set(cache=FALSE, message=FALSE, echo=TRUE, results="markup")
options(width=60)
```

```{r data}
library(EDASeq)
library(yeastRNASeq)
library(leeBamViews)
```

# Reading in unaligned and aligned read data {#secRead}

## Unaligned reads

Unaligned (unmapped) reads stored in FASTQ format may be managed via
the class `FastqFileList` imported from `ShortRead`.
Information related to the libraries sequenced in each lane can be
stored in the `elementMetadata` slot of the
`FastqFileList` object.

```{r import-raw}
files <- list.files(file.path(system.file(package = "yeastRNASeq"),
                              "reads"), pattern = "fastq", full.names = TRUE)
names(files) <- gsub("\\.fastq.*", "", basename(files))
met <- DataFrame(conditions=c(rep("mut",2), rep("wt",2)),
                 row.names=names(files))
fastq <- FastqFileList(files)
elementMetadata(fastq) <- met
fastq
```

## Aligned reads

The package can deal with aligned (mapped) reads in BAM format, using
the class `BamFileList` from `Rsamtools`.  Again, the
`elementMetadata` slot can be used to store lane-level sample
information.

```{r import-aligned}
files <- list.files(file.path(system.file(package = "leeBamViews"), "bam"),
                    pattern = "bam$", full.names = TRUE)
names(files) <- gsub("\\.bam", "", basename(files))

gt <- gsub(".*/", "", files)
gt <- gsub("_.*", "", gt)
lane <- gsub(".*(.)$", "\\1", gt)
geno <- gsub(".$", "", gt)

pd <- DataFrame(geno=geno, lane=lane,
                row.names=paste(geno,lane,sep="."))

bfs <- BamFileList(files)
elementMetadata(bfs) <- pd
bfs
```


# Read-level EDA


## Numbers of unaligned and aligned reads

One important check for quality control is to look at the total number
of reads produced in each lane, the number and the percentage of reads mapped to a
reference genome. A low total
number of reads might be a symptom of low quality of the input RNA,
while a low mapping percentage might indicate poor quality of the
reads (low complexity), problems with the reference genome, or
mislabeled lanes.

```{r plot-total}
colors <- c(rep(rgb(1,0,0,alpha=0.7),2),
            rep(rgb(0,0,1,alpha=0.7),2),
            rep(rgb(0,1,0,alpha=0.7),2),
            rep(rgb(0,1,1,alpha=0.7),2))
barplot(bfs,las=2,col=colors)
```

The figure, produced using the `barplot` method for the
`BamFileList` class, displays the number of mapped reads for
the subset of the yeast dataset included in the package
`leeBamViews`.  Unfortunately, `leeBamViews` does
not provide unaligned reads, but barplots of the total number of reads
can be obtained using the `barplot` method for the
`FastqFileList` class. Analogously, one can plot the percentage
of mapped reads with the `plot` method with signature
`c(x="BamFileList", y="FastqFileList")`. See the manual pages for
details.

## Read quality scores

As an additional quality check, one can plot the mean per-base (i.e.,
per-cycle) quality of the unmapped or mapped reads in every lane.

```{r plot-total-2}
plotQuality(bfs,col=colors,lty=1)
legend("topright",unique(elementMetadata(bfs)[,1]), fill=unique(colors))
```

## Individual lane summaries

If one is interested in looking more thoroughly at one lane, it is
possible to display the per-base distribution of quality scores for
each lane and the number of mapped reads
stratified by chromosome or strand. As expected,
all the reads are mapped to chromosome XIII.

```{r plot-qual}
plotQuality(bfs[[1]],cex.axis=.8)
barplot(bfs[[1]],las=2)
```

## Read nucleotide distributions

A potential source of bias is related to the sequence composition of
the reads. The function `plotNtFrequency` plots the
per-base nucleotide frequencies for all the reads in a given
lane.

```{r plot-nt}
plotNtFrequency(bfs[[1]])
```


# Gene-level EDA

Examining statistics and quality metrics at a read level can help in
discovering problematic libraries or systematic biases in one or more
lanes. Nevertheless, some biases can be difficult to detect at this
scale and gene-level EDA is equally important.

## Classes and methods for gene-level counts

There are several Bioconductor packages for aggregating reads over
genes (or other genomic regions, such as, transcripts and exons) given
a particular genome annotation, e.g., `IRanges`,
`ShortRead`, `Genominator`, `Rsubread`. See
their respective vignettes for details.

Here, we consider this step done and load the object
`geneLevelData` from `yeastRNASeq`, which provides
gene-level counts for 2 wild-type and 2 mutant lanes from the yeast
dataset of `lee2008novel` (see the `Genominator`
vignette for an example on the same dataset).

```{r load-gene-level}
data(geneLevelData)
head(geneLevelData)
```

Since it is useful to explore biases related to length and GC-content,
the `EDASeq` package provides, for illustration purposes,
length and GC-content for _S. cerevisiae_ genes (based on SGD
annotation, version r64 [@sgd]).

Functionality for automated retrieval of gene length and GC-content
is introduced in the last section of the vignette.


```{r load-lgc}
data(yeastGC)
head(yeastGC)
data(yeastLength)
head(yeastLength)
```

First, we filter the non-expressed genes, i.e., we consider only the
genes with an average read count greater than 10 across the four lanes
and for which we have length and GC-content information.

```{r filter}
filter <- apply(geneLevelData,1,function(x) mean(x)>10)
table(filter)
common <- intersect(names(yeastGC),
                    rownames(geneLevelData[filter,]))
length(common)
```

This leaves us with `r length(common)` genes.

The `EDASeq` package provides the `SeqExpressionSet`
class to store gene counts, (lane-level) information on the sequenced
libraries, and (gene-level) feature information.  We use the data
frame `met` created in Section `secRead` for the
lane-level data.  As for the feature data, we use gene length and
GC-content.

```{r create-object}
feature <- data.frame(gc=yeastGC,length=yeastLength)
data <- newSeqExpressionSet(counts=as.matrix(geneLevelData[common,]),
                            featureData=feature[common,],
                            phenoData=data.frame(
                              conditions=factor(c(rep("mut",2),rep("wt",2))),
                              row.names=colnames(geneLevelData)))
data
```

Note that the row names of `counts` and `featureData`
must be the same; likewise for the row names of `phenoData`
and the column names of `counts`.  The expression values can be accessed with `counts`, the lane information with `pData`,
and the feature information with `fData`.

```{r show-data}
head(counts(data))
pData(data)
head(fData(data))
```

The `SeqExpressionSet` class has two additional slots:
`normalizedCounts` and `offset` (matrices of the same dimension as `counts`),
which may be used to store a matrix of normalized counts and of
normalization offsets, respectively, to be used for subsequent analyses (see Section
\ref{secDE} and the `edgeR` vignette for details on the
role of offsets). If not specified, the offset is initialized as a matrix
of zeros.

```{r show-offset}
head(offst(data))
```

## Between-lane distribution of gene-level counts

One of the main considerations when dealing with gene-level counts is
the difference in count distributions between lanes. The
`boxplot` method provides an easy way to produce boxplots of
the logarithms of the gene counts in each lane.

```{r boxplot-genelevel}
boxplot(data,col=colors[1:4])
```

The `MDPlot` method produces a mean-difference plot (MD-plot)
of read counts for two lanes.

```{r md-plot}
MDPlot(data,c(1,3))
```

## Over-dispersion

Although the Poisson distribution is a natural and simple way to model
count data, it has the limitation of assuming equality of the mean and
variance. For this reason, the negative binomial distribution has been
proposed as an alternative when the data show over-dispersion. The
function `meanVarPlot` can be used to check whether the
count data are over-dispersed (for the Poisson distribution, one would
expect the points in the following Figures to be evenly
scattered around the black line).

```{r plot-mean-var}
meanVarPlot(data[,1:2], log=TRUE, ylim=c(0,16))
meanVarPlot(data, log=TRUE, ylim=c(0,16))
```

Note that the mean-variance relationship should be examined within
replicate lanes only (i.e., conditional on variables expected to
contribute to differential expression). For the yeast dataset, it is
not surprising to see no evidence of over-dispersion for the two
mutant technical replicate lanes; likewise for
the two wild-type lanes. However, one expects over-dispersion in the
presence of biological variability, when considering at once all four mutant and wild-type lanes
[@anders2010differential,@bullard2010evaluation,@robinson2010edger].


## Gene-specific effects on read counts

Several authors have reported selection biases related to sequence
features such as gene length, GC-content, and mappability
[@bullard2010evaluation,@hansen2011removing,@oshlack2009transcript,@risso2011gc].

In the following figure, obtained using `biasPlot`, one can
see the dependence of gene-level counts on GC-content. The same plot
could be created for gene length or mappability instead of GC-content.

```{r plot-gc}
biasPlot(data, "gc", log=TRUE, ylim=c(1,5))
```

To show that GC-content dependence can bias differential expression
analysis, one can produce stratified boxplots of the log-fold-change
of read counts from two lanes using the `biasBoxplot` method.
Again, the same type of plots can be created
for gene length or mappability.

```{r boxplot-gc}
lfc <- log(counts(data)[,3]+0.1) - log(counts(data)[,1]+0.1)
biasBoxplot(lfc, fData(data)$gc)
```


# Normalization

Following [@risso2011gc], we consider two main types of effects
on gene-level counts: (1) within-lane gene-specific (and possibly
lane-specific) effects, e.g., related to gene length or GC-content,
and (2) effects related to between-lane distributional differences,
e.g., sequencing depth. Accordingly,
`withinLaneNormalization` and
`betweenLaneNormalization` adjust for the first and second
type of effects, respectively.  We recommend to normalize for
within-lane effects prior to between-lane normalization.

We implemented four within-lane normalization methods, namely: loess
robust local regression of read counts (log) on a gene feature such as
GC-content (`loess`), global-scaling between feature strata
using the median (`median`), global-scaling between feature
strata using the upper-quartile (`upper`), and full-quantile
normalization between feature strata (`full`). For a discussion
of these methods in context of GC-content normalization see
[@risso2011gc].

```{r normalization}
dataWithin <- withinLaneNormalization(data,"gc", which="full")
dataNorm <- betweenLaneNormalization(dataWithin, which="full")
```

Regarding between-lane normalization, the package implements three of
the methods introduced in [@bullard2010evaluation]:
global-scaling using the median (`median`), global-scaling using
the upper-quartile (`upper`), and full-quantile normalization
(`full`).

The next figure shows how after full-quantile within- and
between-lane normalization, the GC-content bias is reduced and the
distribution of the counts is the same in each lane.

```{r plot-gc-norm}
biasPlot(dataNorm, "gc", log=TRUE, ylim=c(1,5))
boxplot(dataNorm, col=colors)
```

## Offset 

Some authors have argued that it is better to leave the count data
unchanged to preserve their sampling properties and instead use an
offset for normalization purposes in the statistical model for read
counts
[@anders2010differential,@hansen2011removing,@robinson2010edger]. This
can be achieved easily using the argument `offset` in both
normalization functions.

```{r norm-offset}
dataOffset <- withinLaneNormalization(data,"gc",
                                      which="full",offset=TRUE)
dataOffset <- betweenLaneNormalization(dataOffset,
                                       which="full",offset=TRUE)
```

Note that the `dataOffset` object will have both normalized
counts and offset stored in their respective slots.


# Differential expression analysis

One of the main applications of RNA-Seq is differential expression
analysis.  The normalized counts (or the original counts and the
offset) obtained using the `EDASeq` package can be supplied
to packages such as `edgeR` [@robinson2010edger] or
`DESeq2` [@deseq2] to find differentially
expressed genes. This section should be considered only as an
illustration of the compatibility of the results of `EDASeq`
with two of the most widely used packages for differential expression;
we refer ther reader to the edgeR's user guide and to the DESeq2 vignettes for more details on the methods implemented there.

## edgeR

We can perform a differential expression analysis with
`edgeR` based on the original counts by passing an offset to
the generalized linear model.  See the `edgeR` vignette for details
about how to perform a differential expression analysis with more complex designs or more robust approaches.

```{r edger}
library(edgeR)
design <- model.matrix(~conditions, data=pData(dataOffset))

y <- DGEList(counts=counts(dataOffset),
             group=pData(dataOffset)$conditions)
y$offset <- -offst(dataOffset)
y <- estimateDisp(y, design)

fit <- glmFit(y, design)
lrt <- glmLRT(fit, coef=2)
topTags(lrt)
```

## DESeq2

We can perform the same differential expression analysis with
`DESeq2`.

```{r deseq}
library(DESeq2)
dds <- DESeqDataSetFromMatrix(countData = counts(dataOffset),
                              colData = pData(dataOffset),
                              design = ~ conditions)

normFactors <- exp(-1 * offst(dataOffset))
normFactors <- normFactors / exp(rowMeans(log(normFactors)))
normalizationFactors(dds) <- normFactors

dds <- DESeq(dds)
res <- results(dds)
res
```

# Definitions and conventions

## Rounding

After either within-lane or between-lane normalization, the expression
values are not counts
anymore. However, their distribution still shows some typical features
of counts distribution (e.g., the variance depends on the mean).
Hence, for most applications, it is useful to round the normalized
values to recover count-like values, which we refer to as "pseudo-counts".

By default, both
`withinLaneNormalization` and
`betweenLaneNormalization` round the normalized values to
the closest integer. This behavior can be changed by specifying
`round=FALSE`. This gives the user more flexibility and assures
that rounding approximations do not affect subsequent computations
(e.g., recovering the offset from the normalized counts).

## Zero counts

To avoid problems in the computation of logarithms (e.g. in log-fold-changes), we add a small positive constant (namely $0.1$) to the
counts. For instance, the log-fold-change between $y_1$ and $y_2$ is
defined as
\begin{equation*}
  \frac{\log(y_1 + 0.1)}{\log(y_2 + 0.1)}.
\end{equation*}

## Offset
We define an offset in the normalization as
\begin{equation*}
  o = \log(y_{norm} + 0.1) - \log(y_{raw} + 0.1),
\end{equation*}
where $y_{norm}$ and $y_{raw}$ are the normalized and raw counts, respectively.

One can easily recover the normalized data from the raw counts and
offset, as shown here:

```{r unrounded}
dataNorm <- betweenLaneNormalization(data, round=FALSE, offset=TRUE)

norm1 <- normCounts(dataNorm)
norm2 <- exp(log(counts(dataNorm) + 0.1 ) + offst(dataNorm)) - 0.1

head(norm1 - norm2)
```

Note that the small constant added in the definition of offset does
not matter when pseudo-counts are considered, i.e.,

```{r rounded}
head(round(normCounts(dataNorm)) - round(counts(dataNorm) * exp(offst(dataNorm))))
```

We defined the offset as the log-ratio between normalized and raw
counts. However, the `edgeR` functions expect as offset
argument the log-ratio between raw and normalized counts. One must use
`-offst(offsetData)` as the offset argument of `edgeR`.


# Retrieving gene length and GC-content

Two essential features the gene-level EDA normalizes for are gene length and
GC-content. As users might wish to automatically retrieve this information, we
provide the function `getGeneLengthAndGCContent`. Given selected
ENTREZ or ENSEMBL gene IDs and the organism under investigation, this can be
done either based on BioMart (default) or using BioC annotation utilities.

```{r getLengthAndGC, eval=FALSE}
getGeneLengthAndGCContent(id=c("ENSG00000012048", "ENSG00000139618"), org="hsa")
```

Accordingly, we can retrieve the precalculated yeast data that has been used
throughout the vignette via

```{r getLengthAndGC-full, eval=FALSE}
fData(data) <- getGeneLengthAndGCContent(featureNames(data),
                                              org="sacCer3", mode="org.db")
```

# SessionInfo

```{r sessionInfo}
sessionInfo()
```

# References

\name{biasPlot-methods}
\docType{methods}
\alias{biasPlot}
\alias{biasPlot-methods}
\alias{biasPlot,matrix,numeric-method}
\alias{biasPlot,SeqExpressionSet,character-method}
\title{  Methods for Function \code{biasPlot} in Package \pkg{EDASeq} }
\description{
\code{biasPlot} produces a plot of the \code{\link{lowess}} regression of the counts on a covariate of interest, tipically the GC-content or the length of the genes.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "matrix", y = "numeric")}}{
It plots a line representing the regression of every column of the matrix \code{x} on the numeric covariate \code{y}. One can pass the usual graphical parameters as additional arguments (see \code{\link{par}}).
}

\item{\code{signature(x = "SeqExpressionSet", y = "character")}}{
It plots a line representing the regression of every lane in \code{x} on the covariate specified by \code{y}. \code{y} must be one of the column of the \code{featureData} slot of the \code{x} object. One can pass the usual graphical parameters as additional arguments (see \code{\link{par}}). The parameter \code{color_code} (optional) must be a number specifying the column of \code{phenoData} to be used for color-coding. By default it is color-coded according to the first column of \code{phenoData}. If \code{legend=TRUE} and \code{col} is not specified a legend with the information stored in \code{phenoData} is added.
}
}}
\keyword{methods}

\examples{
library(yeastRNASeq)
data(geneLevelData)
data(yeastGC)

sub <- intersect(rownames(geneLevelData), names(yeastGC))

mat <- as.matrix(geneLevelData[sub,])

data <- newSeqExpressionSet(mat,
                            phenoData=AnnotatedDataFrame(
                                      data.frame(conditions=factor(c("mut", "mut", "wt", "wt")),
                                                 row.names=colnames(geneLevelData))),
                            featureData=AnnotatedDataFrame(data.frame(gc=yeastGC[sub])))

biasPlot(data,"gc",ylim=c(0,5),log=TRUE)

}

\name{plotQuality-methods}
\docType{methods}
\alias{plotQuality}
\alias{plotQuality-methods}
\alias{plotQuality,BamFileList-method}
\alias{plotQuality,BamFile-method}
\alias{plotQuality,FastqFileList-method}
\title{  Methods for Function \code{plotQuality} in Package \pkg{EDASeq} }
\description{
\code{plotQuality} produces a plot of the quality of the reads.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "BamFileList")}}{
It produces a plot that summarizes the per-base mean quality of the reads of each BAM file in \code{x}.
}

\item{\code{signature(x = "BamFile")}}{
It produces a boxplot of the per-base distribution of the quality scores of the reads in \code{x}.
}

\item{\code{signature(x = "FastqFileList")}}{
It produces a plot that summarizes the per-base mean quality of the reads of each FASTQ file in \code{x}. 
}

}}

\section{Details}{
Since FASTQ files can be very long, it can be very expensive to process a whole file. One way to avoid this, is to consider a subset of the file and then plot the quality of the subset. As long as one assumes that the subset is random, this is a good approximation. The function \code{\link{FastqSampler}} of \code{ShortRead} can be used for this. See its help page for an example.
}

\keyword{methods}

\name{getGeneLengthAndGCContent}
\alias{getGeneLengthAndGCContent}

\title{Get gene length and GC-content}

\description{
Automatically retrieves gene length and GC-content information from Biomart or org.db packages.
}

\usage{
getGeneLengthAndGCContent(id, org, mode=c("biomart", "org.db"))
}

\arguments{
  \item{id}{
    Character vector of one or more ENSEMBL or ENTREZ gene IDs.
  }
  \item{org}{
    Organism three letter code, e.g. 'hsa' for 'Homo sapiens'. 
    See also: http://www.genome.jp/kegg/catalog/org_list.html;
    In org.db mode, this can be also a specific genome assembly, 
    e.g. 'hg38' or 'sacCer3'.
  }
  \item{mode}{
    Mode to retrieve the information. Defaults to 'biomart'. See Details.
  }
}

\details{
    The 'biomart' mode is based on functionality from the biomaRt 
    packgage and retrieves the required information from the BioMart database.
    This is available for all ENSEMBL organisms and is typically most current, 
    but can be time-consuming when querying several thousand genes at a time.

    The 'org.db' mode uses organism-based annotation packages from
    Bioconductor. This is much faster than the 'biomart' mode, but is only
    available for selected model organism currently supported by  
    BioC annotation functionality. 

    Results for the same gene ID(s) can differ between both modes as they
    are based on different sources for the underlying genome assembly. While
    the 'biomart' mode uses the latest ENSEMBL version, the 'org.db' mode uses
    BioC annotation packages typically built from UCSC. 
}

\value{
A numeric matrix with two columns: gene length and GC-content.
}

\seealso{
    \code{\link{getSequence}} to retrieve a genomic sequence from BioMart,
    \code{\link{genes}} to extract genomic coordinates from a TxDb object,
    \code{\link{getSeq}} to extract genomic sequences from a BSgenome object,
    \code{\link{alphabetFrequency}} to calculate nucleotide frequencies.
}

\author{
Ludwig Geistlinger <Ludwig.Geistlinger@bio.ifi.lmu.de>
}

\examples{
\donttest{
getGeneLengthAndGCContent("ENSG00000012048", "hsa")
}
}

\name{boxplot-methods}
\docType{methods}
\alias{boxplot-methods}
\alias{boxplot,FastqQuality-method}
\alias{boxplot,SeqExpressionSet-method}
\title{  Methods for Function \code{boxplot} in Package \pkg{EDASeq} }
\description{
High-level functions to produce boxplots of some complex objects.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "FastqQuality")}}{
It plots the distribution of the quality per read position.
}

\item{\code{signature(x = "SeqExpressionSet")}}{
It plots the distribution of the log counts in each lane of \code{x}.
}
}}
\keyword{methods}

\name{yeastLength}
\docType{data}
\alias{yeastLength}
\title{Length of \emph{S. Cerevisiae} genes}
\description{
            This data set gives the length (in base pairs) of the genes of \emph{S. Cerevisiae},
	    from SGD release 64 annotation. 
}
\format{A vector containing 6717 observations.}
\source{SGD release 64: \url{http://www.yeastgenome.org}}
\keyword{datasets}

\name{barplot-methods}
\docType{methods}
\alias{barplot-methods}
\alias{barplot,BamFile-method}
\alias{barplot,BamFileList-method}
\alias{barplot,FastqFileList-method}
\title{  Methods for Function \code{barplot} in Package \pkg{EDASeq} }
\description{
High-level functions to produce barplots of some complex objects.
}
\section{Methods}{
\describe{

\item{\code{signature(height = "BamFile")}}{
Usage: barplot(height,strata=c("rname","strand"))
It produces a barplot of the total number of reads in each chromosome (if "rname") or strand.
}

\item{\code{signature(height = "BamFileList")}}{
It produces a barplot of the total number of reads in each object in \code{height}. If \code{unique=TRUE} is specified, it stratified the total by uniquely/non-uniquely mapped reads.
}

\item{\code{signature(height = "FastqFileList")}}{
It produces a barplot of the total number of reads in each object in \code{height}.
}

}}
\keyword{methods}

\name{plotNtFrequency-methods}
\docType{methods}
\alias{plotNtFrequency}
\alias{plotNtFrequency-methods}
\alias{plotNtFrequency,BamFile-method}
\alias{plotNtFrequency,ShortRead-method}
\title{ Methods for Function \code{plotNtFrequency} in Package \pkg{EDASeq} }
\description{
Plots the nucleotide frequencies per position.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "ShortRead")}}{
}

\item{\code{signature(x = "BamFile")}}{
}

}

It plots the nucleotide frequencies per position, averaging all the reads in \code{x}.

}
\keyword{methods}

\name{yeastGC}
\docType{data}
\alias{yeastGC}
\title{GC-content of \emph{S. Cerevisiae} genes}
\description{
            This data set gives the GC-content (proportion of G and C) of the genes of \emph{S. Cerevisiae},
	    from SGD release 64 annotation. 
}
\format{A vector containing 6717 observations.}
\source{SGD release 64: \url{http://www.yeastgenome.org}}
\keyword{datasets}

\name{biasBoxplot-methods}
\docType{methods}
\alias{biasBoxplot}
\alias{biasBoxplot-methods}
\alias{biasBoxplot,numeric,numeric,numeric-method}
\alias{biasBoxplot,numeric,numeric-method}
\title{  Methods for Function \code{biasBoxplot} in Package \pkg{EDASeq} }
\description{
\code{biasBoxplot} produces a boxplot representing the distribution of a quantity of interest (e.g. gene counts, log-fold-changes, ...) stratified by a covariate (e.g. gene length, GC-contet, ...).
}

\usage{
biasBoxplot(x,y,num.bins,...)
}

\arguments{
\item{x}{A numeric vector with the quantity of interest (e.g. gene counts, log-fold-changes, ...)}
\item{y}{A numeric vector with the covariate of interest (e.g. gene length, GC-contet, ...)}
\item{num.bins}{A numeric value specifying the number of bins in wich to stratify \code{y}. Default to 10.}
\item{...}{See \code{\link{par}}}
}


\section{Methods}{
\describe{

\item{\code{signature(x = "numeric", y = "numeric", num.bins = "numeric")}}{
It plots a line representing the regression of every column of the matrix \code{x} on the numeric covariate \code{y}. One can pass the usual graphical parameters as additional arguments (see \code{\link{par}}).
}

}}
\keyword{methods}

\examples{
library(yeastRNASeq)
data(geneLevelData)
data(yeastGC)

sub <- intersect(rownames(geneLevelData), names(yeastGC))

mat <- as.matrix(geneLevelData[sub,])

data <- newSeqExpressionSet(mat,
                            phenoData=AnnotatedDataFrame(
                                      data.frame(conditions=factor(c("mut", "mut", "wt", "wt")),
                                                 row.names=colnames(geneLevelData))),
                            featureData=AnnotatedDataFrame(data.frame(gc=yeastGC[sub])))

lfc <- log(geneLevelData[sub, 3] + 1) - log(geneLevelData[sub, 1] + 1)

biasBoxplot(lfc, yeastGC[sub], las=2, cex.axis=.7)

}

\name{meanVarPlot-methods}
\docType{methods}
\alias{meanVarPlot}
\alias{meanVarPlot-methods}
\alias{meanVarPlot,SeqExpressionSet-method}
\title{ Methods for Function \code{meanVarPlot} in Package \pkg{EDASeq}}
\description{
\code{meanVarPlot} produces a \code{smoothScatter} plot of the mean variance relation.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "SeqExpressionSet")}}{
It takes as additional argument \code{log}, which if true consider the logarithm of the counts before computing mean and variance. To avoid missing values, we consider the maximum between 0 and the log of the counts. Along with the scatter plot the function plots a line representing the \code{\link{lowess}} fit.
}
}}
\keyword{methods}

\name{plot-methods}
\docType{methods}
\alias{plot-methods}
\alias{plot,BamFileList,FastqFileList-method}
\title{  Methods for Function \code{plot} in Package \pkg{EDASeq} }
\description{
High-level function to produce plots given one \code{BamFileList} object and one \code{FastqFileList} object.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "BamFileList", y = "FastqFileList")}}{
It produce a barplot of the percentage of mapped reads. If \code{strata=TRUE} it stratifies the bars according to the unique/non-unique mapped reads.
To be meaningful, \code{x} should be a set of aligned reads and \code{y} a set of raw reads on the same samples.
}
}}
\keyword{methods}

\name{betweenLaneNormalization-methods}
\docType{methods}
\alias{betweenLaneNormalization}
\alias{betweenLaneNormalization-methods}
\alias{betweenLaneNormalization,matrix-method}
\alias{betweenLaneNormalization,SeqExpressionSet-method}
\title{ Methods for Function \code{betweenLaneNormalization} in Package \pkg{EDASeq} }
\description{
 Between-lane normalization for sequencing depth and possibly other distributional differences between lanes.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "matrix")}}{
It returns a matrix with the normalized counts if \code{offset=FALSE} or with the offset if \code{offset=TRUE}.
}

\item{\code{signature(x = "SeqExpressionSet")}}{
It returns a \code{linkS4class{SeqExpressionSet}} with the normalized counts in the \code{normalizedCounts} slot and with the offset in the \code{offset} slot (if \code{offset=TRUE}).
}
}}

\usage{
betweenLaneNormalization(x, which=c("median","upper","full"), offset=FALSE, round=TRUE)
}

\arguments{
\item{x}{A numeric matrix representing the counts or a \code{\linkS4class{SeqExpressionSet}} object.}
\item{which}{Method used to normalized. See the details section and the reference below for details.}
\item{offset}{Should the normalized value be returned as an offset leaving the original counts unchanged?}
\item{round}{If TRUE the normalization returns rounded values (pseudo-counts). Ignored if offset=TRUE.}
}



\details{
This method implements three normalizations described in Bullard et al. (2010).
The methods are:
\describe{
\item{\code{median}:}{a scaling normalization that forces the median of each lane to be the same.}
\item{\code{upper}:}{the same but with the upper quartile.}
\item{\code{full}:}{a non linear full quantile normalization, in the spirit of the one used in microarrays.}
}
}

\author{
Davide Risso.
}

\references{
J. H. Bullard, E. A. Purdom, K. D. Hansen and S. Dudoit (2010). Evaluation of statistical methods for normalization and differential expression in mRNA-Seq experiments. BMC Bioinformatics Vol. 11, Article 94.

D. Risso, K. Schwartz, G. Sherlock and S. Dudoit (2011). GC-Content Normalization for RNA-Seq Data. Manuscript in Preparation.
}

\examples{
library(yeastRNASeq)
data(geneLevelData)
data(yeastGC)

sub <- intersect(rownames(geneLevelData), names(yeastGC))

mat <- as.matrix(geneLevelData[sub, ])

data <- newSeqExpressionSet(mat,
                            phenoData=AnnotatedDataFrame(
                                      data.frame(conditions=factor(c("mut", "mut", "wt", "wt")),
                                                 row.names=colnames(geneLevelData))),
                            featureData=AnnotatedDataFrame(data.frame(gc=yeastGC[sub])))

norm <- betweenLaneNormalization(data, which="full", offset=FALSE)

}

\keyword{methods}

\name{newSeqExpressionSet}
\alias{newSeqExpressionSet}

\title{
Function to create a new \code{\linkS4class{SeqExpressionSet}} object.
}
\description{
User-level function to create new objects of the class \code{\linkS4class{SeqExpressionSet}}.
}
\usage{
newSeqExpressionSet(counts,
                    normalizedCounts = matrix(data=NA, nrow=nrow(counts), ncol=ncol(counts), dimnames=dimnames(counts)),
                    offset = matrix(data=0, nrow=nrow(counts), ncol=ncol(counts), dimnames=dimnames(counts)),
                    phenoData = annotatedDataFrameFrom(counts, FALSE),
                    featureData = annotatedDataFrameFrom(counts, TRUE),
                    ...)
}
\arguments{
  \item{counts}{
  A matrix containing the counts for an RNA-Seq experiment. One column for each lane and one row for each gene.
}
  \item{normalizedCounts}{
   A matrix with the same dimensions of \code{counts} with the normalized counts.
}
  \item{offset}{
 A matrix with the same dimensions of \code{counts} defining the offset (usually useful for normalization purposes). See the package vignette for a discussion on the offset.
}
  \item{phenoData}{
A data.frame or \code{\link{AnnotatedDataFrame}} with sample information, such as biological condition, library preparation protocol, flow-cell,...
}
  \item{featureData}{
A data.frame or \code{\link{AnnotatedDataFrame}} with feature information, such as gene length, GC-content, ...
}
  \item{\dots}{
 Other arguments will be passed to the constructor inherited from \code{\linkS4class{eSet}}.
}
}

\value{
An object of class \code{\linkS4class{SeqExpressionSet}}.
}

\author{
Davide Risso
}

\seealso{
\code{\linkS4class{SeqExpressionSet}}
}
\examples{

counts <- matrix(data=0, nrow=100, ncol=4)
for(i in 1:4) {
counts[, i] <- rpois(100, lambda=50)
}
cond <- c(rep("A", 2), rep("B", 2))

counts <- newSeqExpressionSet(counts, phenoData=data.frame(conditions=cond))

}

\name{withinLaneNormalization-methods}
\docType{methods}
\alias{withinLaneNormalization}
\alias{withinLaneNormalization-methods}
\alias{withinLaneNormalization,matrix,numeric-method}
\alias{withinLaneNormalization,SeqExpressionSet,character-method}
\title{  Methods for Function \code{withinLaneNormalization} in Package \pkg{EDASeq} }
\description{
 Within-lane normalization for GC-content (or other lane-specific) bias.
}

\section{Methods}{
\describe{
\item{\code{signature(x = "matrix", y = "numeric")}}{

It returns a matrix with the normalized counts if \code{offset=FALSE} or with the offset if \code{offset=TRUE}.

}

\item{\code{signature(x = "SeqExpressionSet", y = "character")}}{

It returns a \code{\linkS4class{SeqExpressionSet}} with the normalized counts in the \code{normalizedCounts} slot and with the offset in the \code{offset} slot (if \code{offset=TRUE}).

}
}}

\usage{
withinLaneNormalization(x, y, which=c("loess","median","upper","full"), offset=FALSE, num.bins=10, round=TRUE)
}

\arguments{
\item{x}{A numeric matrix representing the counts or a \code{\linkS4class{SeqExpressionSet}} object.}
\item{y}{A numeric vector representing the covariate to normalize for (if \code{x} is a matrix) or a character vector with the name of the covariate (if \code{x} is a \code{\linkS4class{SeqExpressionSet}} object). Usually it is the GC-content.}
\item{which}{Method used to normalized. See the details section and the reference below for details.}
\item{offset}{Should the normalized value be returned as an offset leaving the original counts unchanged?}
\item{num.bins}{The number of bins used to stratify the covariate for \code{median}, \code{upper} and \code{full} methods. Ignored if \code{loess}. See the reference for a discussion on the number of bins.}
\item{round}{If TRUE the normalization returns rounded values (pseudo-counts). Ignored if offset=TRUE.}
}

\details{
This method implements four normalizations described in Risso et al. (2011).

The \code{loess} normalization transforms the data by regressing the counts on \code{y} and subtracting the loess fit from the counts to remove the dependence.

The \code{median}, \code{upper} and \code{full} normalizations are based on the stratification of the genes based on \code{y}. Once the genes are stratified in \code{num.bins} strata, the methods work as follows. 
\describe{
\item{\code{median}:}{scales the data to have the same median in each bin.}
\item{\code{upper}:}{the same but with the upper quartile.}
\item{\code{full}:}{forces the distribution of each stratum to be the same using a non linear full quantile normalization, in the spirit of the one used in microarrays.}
}
}

\author{
Davide Risso.
}

\references{
D. Risso, K. Schwartz, G. Sherlock and S. Dudoit (2011). GC-Content Normalization for RNA-Seq Data. Manuscript in Preparation.
}

\examples{
library(yeastRNASeq)
data(geneLevelData)
data(yeastGC)

sub <- intersect(rownames(geneLevelData), names(yeastGC))

mat <- as.matrix(geneLevelData[sub, ])

data <- newSeqExpressionSet(mat,
                            phenoData=AnnotatedDataFrame(
                                      data.frame(conditions=factor(c("mut", "mut", "wt", "wt")),
                                                 row.names=colnames(geneLevelData))),
                            featureData=AnnotatedDataFrame(data.frame(gc=yeastGC[sub])))

norm <- withinLaneNormalization(data, "gc", which="full", offset=FALSE)

}
\keyword{methods}

\name{MDPlot-methods}
\docType{methods}
\alias{MDPlot}
\alias{MDPlot-methods}
\alias{MDPlot,matrix,numeric-method}
\alias{MDPlot,SeqExpressionSet,numeric-method}
\title{  Methods for Function \code{MDPlot} in Package \pkg{EDASeq} }
\description{
\code{MDPlot} produces a mean-difference smooth scatterplot of two lanes in an experiment.
}

\usage{
MDPlot(x,y,...)
}

\arguments{
\item{x}{Either a numeric matrix or a \code{\linkS4class{SeqExpressionSet}} object containing the gene expression.
}
\item{y}{A numeric vecor specifying the lanes to be compared.}
\item{...}{See \code{\link{par}}}
}

\details{
The mean-difference (MD) plot is a useful plot to visualize difference in two lanes of an experiment. From a MDPlot one can see if normalization is needed and if a linear scaling is sufficient or nonlinear normalization is more effective.

The MDPlot also plots a lowess fit (in red) underlying a possible trend in the bias related to the mean expression.

}
\section{Methods}{
\describe{

\item{\code{signature(x = "matrix", y = "numeric")}}{
}

\item{\code{signature(x = "SeqExpressionSet", y = "numeric")}}{

}
}}
\keyword{methods}

\examples{
library(yeastRNASeq)
data(geneLevelData)
data(yeastGC)

sub <- intersect(rownames(geneLevelData), names(yeastGC))

mat <- as.matrix(geneLevelData[sub,])

data <- newSeqExpressionSet(mat,
            phenoData=AnnotatedDataFrame(
                      data.frame(conditions=factor(c("mut", "mut", "wt", "wt")),
                                 row.names=colnames(geneLevelData))),
            featureData=AnnotatedDataFrame(data.frame(gc=yeastGC[sub])))

MDPlot(data,c(1,3))

}

\name{plotPCA-methods}
\docType{methods}
\alias{plotPCA}
\alias{plotPCA-methods}
\alias{plotPCA,matrix-method}
\alias{plotPCA,SeqExpressionSet-method}
\title{  Methods for Function \code{plotPCA} in Package \pkg{EDASeq} }
\description{
\code{plotPCA} produces a Principal Component Analysis (PCA) plot of the counts in \code{object}
}

\usage{
\S4method{plotPCA}{matrix}(object, k=2, labels=TRUE, isLog=FALSE, ...)
\S4method{plotPCA}{SeqExpressionSet}(object, k=2, labels=TRUE, ...)
}

\arguments{
\item{object}{Either a numeric matrix or a \code{\linkS4class{SeqExpressionSet}} object containing the gene expression.}

\item{k}{The number of principal components to be plotted.}

\item{labels}{Logical. If \code{TRUE}, and \code{k=2}, it plots the \code{colnames} of \code{object} as point labels.}

\item{isLog}{Logical. Set to \code{TRUE} if the data are already on the log scale.}

\item{...}{See \code{\link{par}}}
}

\details{
The Principal Component Analysis (PCA) plot is a useful diagnostic plot to highlight differences in the distribution of replicate samples, by projecting the samples into a lower dimensional space.

If there is strong differential expression between two classes, one expects the samples to cluster by class in the first few Principal Components (PCs) (usually 2 or 3 components are enough). This plot also highlights possible batch effects and/or outlying samples.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "matrix")}}{
}

\item{\code{signature(x = "SeqExpressionSet")}}{

}
}}
\keyword{methods}

\examples{
library(yeastRNASeq)
data(geneLevelData)

mat <- as.matrix(geneLevelData)

data <- newSeqExpressionSet(mat,
                            phenoData=AnnotatedDataFrame(
                                      data.frame(conditions=factor(c("mut", "mut", "wt", "wt")),
                                                 row.names=colnames(geneLevelData))))

plotPCA(data, col=rep(1:2, each=2))

}

\name{SeqExpressionSet-class}
\docType{class}
\alias{SeqExpressionSet-class}
\alias{offst}
\alias{offst<-}
\alias{normCounts}
\alias{normCounts<-}
\alias{initialize,SeqExpressionSet-method}
\alias{exprs,SeqExpressionSet-method}
\alias{exprs<-,SeqExpressionSet,ANY-method}
\alias{offst,SeqExpressionSet-method}
\alias{offst<-,SeqExpressionSet,ANY-method}
\alias{offst<-,SeqExpressionSet-method}
\alias{counts,SeqExpressionSet-method}
\alias{counts<-,SeqExpressionSet-method}
\alias{normCounts,SeqExpressionSet-method}
\alias{normCounts<-,SeqExpressionSet,ANY-method}
\alias{normCounts<-,SeqExpressionSet-method}



\title{"SeqExpressionSet" class for collections of short reads}

\description{

This class represents a collection of digital expression data (usually counts from RNA-Seq technology) along with sample information.

}

\section{Objects from the Class}{

  Objects of this class can be created from a call to the
  \code{\link{newSeqExpressionSet}} constructor.

}

\section{Extends}{
	Class \code{eSet}, directly.
	Class \code{VersionedBiobase}, by class \code{eSet}, distance 2.
	Class \code{Versioned}, by class \code{eSet}, distance 3.
}

\section{Slots}{
  Inherited from \code{eSet}:

  \describe{
     \item{\code{assayData}}{Contains matrices with equal dimensions, and with
          column number equal to \code{nrow(phenoData)}.\code{assayData} must
          contain a matrix \code{counts} with rows represening features
          (e.g., genes) and columns representing samples.
          The optional matrices \code{normalizedCounts} and \code{offset} can be added to represent a normalization in terms of pseudo-counts or offset, respectively, to be used for subsequent analyses. See the vignette for details.
          Class: \code{\link{AssayData-class}}.}

    \item{\code{phenoData}}{Sample information. For compatibility with DESeq, there should be at least the column \code{conditions}. See \code{\link{eSet}} for details.}

    \item{\code{featureData}}{Feature information. It is recomended to include at least length and GC-content information. This slot is used for \code{\link{withinLaneNormalization}}. See \code{\link{eSet}} for details.}

    \item{\code{experimentData}}{See \code{\link{eSet}}}

    \item{\code{annotation}}{See \code{\link{eSet}}}

    \item{\code{protocolData}}{See \code{link{eSet}}}
    }
}


\section{Methods}{
  See \code{\link{eSet}} for inherited methods. Additional methods:

  \describe{

    \item{counts}{\code{signature(object="SeqExpressionSet")}: returns the \code{counts} matrix. }

    \item{counts<-}{\code{signature(object = "SeqExpressionSet")}: method to replace the \code{counts} matrix.}

    \item{normCounts}{\code{signature(object="SeqExpressionSet")}: returns the \code{normalizedCounts} matrix. }

    \item{normCounts<-}{\code{signature(object = "SeqExpressionSet")}: method to replace the \code{normalizedCounts} matrix.}

    \item{offst}{\code{signature(object = "SeqExpressionSet")}:  returns the \code{offset} matrix.}

    \item{offst<-}{\code{signature(object = "SeqExpressionSet")}: method to replace the \code{offset} slot.}

    \item{boxplot}{\code{signature(x = "SeqExpressionSet")}: produces a boxplot of the log counts.}

    \item{meanVarPlot}{\code{signature(x = "SeqExpressionSet")}: produces a \code{\link{smoothScatter}} plot of the mean variance relation. See \code{\link{meanVarPlot}} for details.}

    \item{biasPlot}{\code{signature(x = "SeqExpressionSet", y = "character")}: produces a plot of the \code{\link{lowess}} regression of the counts on some covariate of interest (usually GC-content or length). See \code{\link{biasPlot}} for details.}

    \item{wihtinLaneNormalization}{\code{signature(x = "SeqExpressionSet", y = "missing")}: within lane normalization for GC-content (or other lane specific) bias. See \code{\link{withinLaneNormalization}} for details.}

    \item{betweenLaneNormalization}{\code{signature(x = "SeqExpressionSet")}: between lane normalization for sequencing depth and possibly other distributional differences between lanes.  See \code{\link{betweenLaneNormalization}} for details.}

 }
}

\author{Davide Risso <risso.davide@gmail.com>}

\seealso{
  \code{\linkS4class{eSet}}, \code{\link{newSeqExpressionSet}}, \code{\link{biasPlot}}, \code{\link{withinLaneNormalization}}, \code{\link{betweenLaneNormalization}}
}

\examples{

showMethods(class="SeqExpressionSet", where=getNamespace("EDASeq"))

counts <- matrix(data=0, nrow=100, ncol=4)
for(i in 1:4) {
counts[,i] <- rpois(100,lambda=50)
}
cond <- c(rep("A", 2), rep("B", 2))

data <- newSeqExpressionSet(counts, phenoData=AnnotatedDataFrame(data.frame(conditions=cond)))

head(counts(data))
boxplot(data, col=as.numeric(pData(data)[,1])+1)

}

\keyword{classes}

\name{plotRLE-methods}
\docType{methods}
\alias{plotRLE}
\alias{plotRLE-methods}
\alias{plotRLE,matrix-method}
\alias{plotRLE,SeqExpressionSet-method}
\title{  Methods for Function \code{plotRLE} in Package \pkg{EDASeq} }
\description{
\code{plotRLE} produces a Relative Log Expression (RLE) plot of the counts in \code{x}
}

\usage{
plotRLE(x, ...)
}

\arguments{
\item{x}{Either a numeric matrix or a \code{\linkS4class{SeqExpressionSet}} object containing the gene expression.
}
\item{...}{See \code{\link{par}}}
}

\details{
The Relative Log Expression (RLE) plot is a useful diagnostic plot to visualize the differences between the distributions
of read counts across samples. 

It shows the boxplots of the log-ratios of the gene-level read counts of each sample to those of a reference sample (defined as the median across the samples). Ideally, the distributions should be centered around the zero line and as tight as possible. Clear deviations indicate the need for normalization and/or the presence of outlying samples.
}
\section{Methods}{
\describe{

\item{\code{signature(x = "matrix")}}{
}

\item{\code{signature(x = "SeqExpressionSet")}}{

}
}}
\keyword{methods}

\examples{
library(yeastRNASeq)
data(geneLevelData)

mat <- as.matrix(geneLevelData)

data <- newSeqExpressionSet(mat,
                            phenoData=AnnotatedDataFrame(
                                      data.frame(conditions=factor(c("mut", "mut", "wt", "wt")),
                                                 row.names=colnames(geneLevelData))))


plotRLE(data, col=rep(2:3, each=2))

}

\name{EDASeq-package}
\alias{EDASeq-package}
\alias{EDASeq}
\docType{package}
\title{Exploratory Data Analysis and Normalization for RNA-Seq data}
\description{Numerical summaries and graphical representations of some key features of the data along with implementations of both within-lane normalization methods for GC content bias and between-lane normalization methods to adjust for sequencing depth and possibly other differences in distribution.}
\details{
The \code{\linkS4class{SeqExpressionSet}} class is used to store gene-level counts along with sample information. It extends the virtual class \code{\linkS4class{eSet}}. See the help page of the class for details.

"Read-level" information is managed via the \code{\linkS4class{FastqFileList}} and \code{\linkS4class{BamFileList}} classes of \code{\link{Rsamtools}}.

Most used graphic tools for the \code{\linkS4class{FastqFileList}} and \code{\linkS4class{BamFileList}} objects are: 'barplot', 'plotQuality', 'plotNtFrequency'. For \code{\linkS4class{SeqExpressionSet}} objects are: 'biasPlot', 'meanVarPlot', 'MDPlot'.

To perform gene-level normalization use the functions 'withinLaneNormalization' and 'betweenLaneNormalization'.

See the package vignette for a typical Exploratory Data Analysis example.
}
\author{
Davide Risso and Sandrine Dudoit.
Maintainer: Davide Risso <risso.davide@gmail.com>
}
\references{
J. H. Bullard, E. A. Purdom, K. D. Hansen and S. Dudoit (2010). Evaluation of statistical methods for normalization and differential expression in mRNA-Seq experiments. BMC Bioinformatics Vol. 11, Article 94.

D. Risso, K. Schwartz, G. Sherlock and S. Dudoit (2011). GC-Content Normalization for RNA-Seq Data. Technical Report No. 291, Division of Biostatistics, University of California, Berkeley, Berkeley, CA.
}
